//----------------------------------------------------------------------------
//	DUTCONTROL.C
//
//	This module includes functions to control the Alace control lines
//		sampleType, and DataRequest line
//
//	Version 1.0	6/5/13 - Justin Klumpp - Initial Release
//
//----------------------------------------------------------------------------
//
// INCLUDES
#include <m8c.h>        // part specific constants and macros
#include "JIGFunk.h"
#include "DUTControl.h" 

// PUBLIC FUNCTIONS
void DUTControl_sampleTypeHigh(void)
//	enable DUT sampletype line high
//	Modifies: port 0 line 5
//	Effects: asserts line high
//	Returns: nothing
{
	PRT0DR |= SET_SAMPLETYPE;
}

void DUTControl_sampleTypeLow(void)
//	enable DUT sampletype line high
//	Modifies: port 0 line 5
//	Effects: asserts line high
//	Returns: nothing
{
	PRT0DR &= ~SET_SAMPLETYPE;
}


void DUTControl_sendLongPulse(void)
//	send a 500mS pulse on to the DUT control line
//	Modifies: port 0, line 7
//	Effects: asserts line high for 500ms
//	Returns: Nothing
{
 	PRT0DR |= DATA_REQUEST;
	JIGFunk_delay(100);
	JIGFunk_delay(100);
	JIGFunk_delay(100);
	JIGFunk_delay(100);
	PRT0DR &= ~DATA_REQUEST;
}


void DUTControl_sendShortPulse(void)
//	send a 500mS pulse on to the DUT control line
//	Modifies: port 0, line 7
//	Effects: asserts line high for 200ms
//	Returns: Nothing
{
	PRT0DR |= DATA_REQUEST;
	JIGFunk_delay(60);
	PRT0DR &= ~DATA_REQUEST;
}
